---
# Author: Raphaël Jacquot
# Description: Installs a very recent git version (from git)

- debug: "msg='INSTALLING GIT ANSIBLE PACKAGES'"

- name: 'install necessary packages'
  apt:
    name: '{{item}}'
    state: 'latest'
  with_items:
    - 'git'
    - 'python-setuptools'
    - 'python-crypto'
    - 'python-yaml'
    - 'python-jinja2'
    - 'python-paramiko'
    - 'python-netaddr'
    - 'python-dnspython'

# this is supposed to update the repo and install fresh everytime

#- name: 'set proxy for git'
#  shell: 'git config --global http.proxy {{proxy}}'
#  when: '{{ proxy is not undefined and proxy != "" }}' 

#- name: 'position http_proxy'
#  set_fact:
#    http_proxy: '{{ proxy }}'
#  when: '{{ proxy is not undefined and proxy != "" }}'

#- name: 'position http_proxy (empty)'
#  set_fact:
#    http_proxy: ''
#  when: '{{ proxy is undefined }}'

- name: 'get the repo for ansible'
  git:
    repo: 'https://github.com/ansible/ansible.git'
    clone: 'yes'
    update: 'yes'
    recursive: 'yes'
    force: 'yes'
    dest: '/root/ansible'

- name: "remove the extras directory contents to make space for my own version"
  file:
    path: '/root/ansible/lib/ansible/modules/extras'
    state: 'absent'

- name: "get the repo for ansible/extras"
  git:
    repo: 'https://github.com/sxpert/ansible-modules-extras.git'
    clone: 'yes'
    update: 'yes'
    recursive: 'no'
    force: 'yes'
    version: 'sxpert-prod'
    dest: '/root/ansible/lib/ansible/modules/extras'

- name: 'install ansible from previously synced git repo'
  shell: 'python setup.py install >> /var/log/ansible_install.log 2>&1'
  args:
    chdir: '/root/ansible'

- name: 'run setup'
  setup:
  become: 'no'

#- debug: 'var=hostvars[inventory_hostname]'

- name: 'generate .ansible.cfg'
  template:
    src: 'ansible.cfg.j2'
    dest: '{{ansible_user_dir}}/.ansible.cfg'

- name: 'install some packages from ansible-galaxy'
  shell: 'ansible-galaxy install {{ item }}'
  with_items: 
    - 'git+https://github.com/debops/ansible-ifupdown.git'
#  environment:
#    https_proxy: '{{ http_proxy }}'


